
//{{{
void get_misc_link(int linknum, struct filelink *ret)
{
	struct filelink *table = deref_file_ptr(get_w()->desc.misc_links);
	*ret = table[linknum];
}
//}}}
//{{{
void create_companion(int type)
{
	int d[1]; // HACKHACK: Can't put a proper struct on the stack yet, but
	          // this is the same size so it works the same
	get_misc_link(type, d);
	addmonster(d, get_plr()->x, get_plr()->y);
}
//}}}

#define range(a,b) uchar: a; uchar: b;
#define coord(x, y) uchar: x; uchar: y;
//{{{
#define SEQUENCE_PRIMARY   1
#define SEQUENCE_ITEMS     2
#define SEQUENCE_TABLES    3
#define SEQUENCE_STRINGS   4
#define SEQUENCE_MISC      5
#define SEQUENCE_STSIZES   6
#define SEQUENCE_STDATA    7
#define SEQUENCE_BITBUCKET -1
#define SEQUENCE_TEMP      8
//}}}
divert(SEQUENCE_TABLES)

define(@{numStrings@}, 0)

//{{{
define(String,
 @{define(@{numStrings@}, eval(numStrings+1))@{@}dnl
  define(@{DIVERT_RET@}, divnum)@{@}dnl
  divert(SEQUENCE_STRINGS)@{@}
  export STRING_@{@}numStrings@{@};
  string: $1@{@}; even;
  divert(DIVERT_RET)@{@}dnl
  STRING_@{@}numStrings@{@}dnl
 @})
//}}}
//{{{
define(Itemstring,
 @{define(@{numStrings@}, eval(numStrings+1))@{@}dnl
  define(@{DIVERT_RET@}, divnum)@{@}dnl
  divert(SEQUENCE_STRINGS)@{@}
  export STRING_@{@}numStrings@{@};
#ifdef SUPPORT_COLOR
  uchar: 0; uchar: 0;
#endif
  string: $1@{@}; even;
  divert(DIVERT_RET)@{@}dnl
  STRING_@{@}numStrings@{@}dnl
 @})
//}}}
//{{{
define(BEGIN_JUMPTAB,
 @{define(@{tabName@}, $1)
  define(@{numTabEntries@}, 1)
  define(@{tabFreq@}, 0)
  define(@{tabCondition@}, @{$2@})
  even;
 @})
//}}}
//{{{
define(JTENTRY,
 @{define(@{numTabEntries@}, eval(numTabEntries+1))
  divert(SEQUENCE_TEMP)
  link: $1; // Target
  define(@{tabFreq@}, eval(tabFreq+$2))
  uint: tabFreq;
  $3      // Range
 @})
//}}}
//{{{
define(END_JUMPTAB,
 @{divert(SEQUENCE_TABLES)
  even;
  export tabName @{(@} PTR_JUMPTABLE @{)@};
  uint: numTabEntries;
  uint: tabCondition;
  
  link: tabName;
  uint: 0;
  uchar: 1; uchar: 2;  // Impossible condition (min 2, max 1) to prevent generation of self
  undivert(SEQUENCE_TEMP)
 @})
//}}}

define(@{numSTabs@}, 0)
define(@{sTabPos@}, 0)

//{{{
define(BEGIN_SHUFFLETAB,
 @{define(@{tabName@}, $1)
  define(@{numTabEntries@}, 0)
  define(@{numSTabs@}, eval(numSTabs+1))
 @})
//}}}
//{{{
define(STENTRY,
 @{define(@{numTabEntries@}, eval(numTabEntries+1))
  divert(SEQUENCE_STDATA)dnl
  export tabName@{@}_@{@}numTabEntries @{(@} PTR_SHUFFLETAB, sTabPos @{)@};
  define(@{sTabPos@}, eval(sTabPos+1))dnl
  link: $1;
 @})
//}}}
//{{{
define(STENTRYSTRING,
 @{define(@{numTabEntries@}, eval(numTabEntries+1))
  divert(SEQUENCE_STRINGS)dnl
  export tabName@{@}_@{@}numTabEntries@{@}_string;
  string: $1; even;
  divert(SEQUENCE_STDATA)dnl
  export tabName@{@}_@{@}numTabEntries @{(@} PTR_SHUFFLETAB, sTabPos @{)@};
  define(@{sTabPos@}, eval(sTabPos+1))dnl
  link: tabName@{@}_@{@}numTabEntries@{@}_string;
 @})
//}}}
//{{{
define(STENTRYITEM,
 @{define(@{numTabEntries@}, eval(numTabEntries+1))
  divert(SEQUENCE_STRINGS)dnl
  export tabName@{@}_@{@}numTabEntries@{@}_string;
#ifdef SUPPORT_COLOR
  uchar: $1; uchar: $1;
#endif
  string: $2; even;
  divert(SEQUENCE_STDATA)dnl
  export tabName@{@}_@{@}numTabEntries @{(@} PTR_SHUFFLETAB, sTabPos @{)@};
  define(@{sTabPos@}, eval(sTabPos+1))dnl
  link: tabName@{@}_@{@}numTabEntries@{@}_string;
 @})
//}}}
//{{{
define(END_SHUFFLETAB,
 @{divert(SEQUENCE_STSIZES)dnl
  uint: numTabEntries;
  divert(SEQUENCE_BITBUCKET)dnl
 @})
//}}}

divert(SEQUENCE_TABLES)
export MISC_LINKS;
//{{{
link:MONSTER_SUMMON_SKELETON;
link:MONSTER_SUMMON_ZOMBIE;
link:MONSTER_SUMMON_MUMMY;
link:MONSTER_SUMMON_WRAITH;
link:MONSTER_SUMMON_ANGEL;
link:MONSTER_PET_HORSE;
link:MONSTER_BRIDGE_TROLL;
link:MONSTER_SKELETON;
link:MONSTER_FIREELEMENTAL;
link:MONSTER_VORTEX;
link:MONSTER_WATERELEMENTAL;
//}}}
//{{{
#define LINK_SUMMON_SKELETON 0
#define LINK_SUMMON_ZOMBIE   1
#define LINK_SUMMON_MUMMY    2
#define LINK_SUMMON_WRAITH   3
#define LINK_SUMMON_ANGEL    4
#define LINK_PET_HORSE       5
#define LINK_BRIDGE_TROLL    6
#define LINK_SKELETON        7
#define LINK_FIRE_ELEMENTAL  8
#define LINK_VORTEX          9
#define LINK_WATER_ELEMENTAL 10
//}}}

divert(SEQUENCE_STSIZES)
even;
export STSIZES;
divert(SEQUENCE_STDATA)
even;
export STDATA;
