// score.h
/// @file
/// @brief High-score keeping
/// @sa score.c

#ifndef SCORE_H
#define SCORE_H

#define CAUSE_OF_DEATH_MAX_LENGTH 32

typedef struct high_score
{
	ulong points;
	char cause_of_death[CAUSE_OF_DEATH_MAX_LENGTH];
} high_score;

typedef struct high_scores
{
	high_score scores[NUM_SCORES];
	ulong num_games;
	ulong checksum;
} high_scores;

#endif //SCORE_H

